//+------------------------------------------------------------------+
//|          Indiktor                                            
//|          Staen news z Forexfactory                             
//|          a vypnut Auto tradingu urenou dobu ped a po zprvch 
//+------------------------------------------------------------------+

#property stacksize 1000000
#property indicator_chart_window
#property strict

#include <WinUser32.mqh>

#import "user32.dll"
int GetAncestor(int hWnd,int gaFlags);
int PostMessageA(int hWnd,int Msg,int wParam,int lParam);
int GetDlgItem(int hDlg,int nIDDlgItem);
#import

#import "kernel32.dll"
void OutputDebugStringW(string msg);
#import

#import "wininet.dll"
int InternetOpenW(string sAgent,int lAccessType,string sProxyName="",string sProxyBypass="",int lFlags=0);
int InternetOpenUrlW(int hInternetSession,string sUrl,string sHeaders="",int lHeadersLength=0,uint lFlags=0,int lContext=0);
int InternetReadFile(int hFile,uchar  &sBuffer[],int lNumBytesToRead,int &lNumberOfBytesRead);
int InternetCloseHandle(int hInet);
#import

#define newsURL "http://www.forexfactory.com/ffcal_week_this.xml"
#define EABUTTON 33020

#define INTERNET_FLAG_PRAGMA_NOCACHE    0x00000100 // Forces the request to be resolved by the origin server, even if a cached copy exists on the proxy.
#define INTERNET_FLAG_NO_CACHE_WRITE    0x04000000 // Does not add the returned entity to the cache. 
#define INTERNET_FLAG_RELOAD            0x80000000 // Forces a download of the requested file, object, or directory listing from the origin server, not from the cache.

#property script_show_inputs
//--- Impact
enum impacty
  {
   all,
   low,
   medium,
   high,
  };
// jak brt minimln impact, 0 = vechno, 1 = low, 2 = medium, 3 = high
input impacty impactBratAspon=2; // Minimln Impact

input bool USD_Ano=true; //USD
input bool EUR_Ano=true; //EUR
input bool GBP_Ano=true; //GBP
input bool JPY_Ano=true; //JPY
input bool AUD_Ano=false; //AUD
input bool CAD_Ano=false; //CAD
input bool NZD_Ano=false; //NZD
input bool CHF_Ano=false; //CHF
input bool CNY_Ano=false; //CNY 

input bool DisableExpertAdvisors=true; // Vypnat Auto Trading?
input string vubecnic;// Mus bt minimln 2 minuty
input int DEA_BeforeNewsMin=20; // Kolik minut ped zprvou
input int DEA_AfterNewsMin=30; // Kolik minut po zprv

input bool cervenyGrafZap=true; // Obarvit graf pi vypnut EA?
input color barvaWarning=clrRed; // Barva grafu pi vypnut EA

bool downloadOK=false; //Je soubor news.xml staen v podku?

string events[];
short pocetEvents; // Od XMLdoPole je tu poet dat v data[][7]
string data[][7]; // tady jsou data - title, country, date, time, impact, forecast, previous
char poKolikaHodDownload=4; // Po kolika hodinch se maj znovu stahovat data news

string sTags[7] = {"<title>", "<country>", "<date><![CDATA[", "<time><![CDATA[", "<impact><![CDATA[", "<forecast><![CDATA[", "<previous><![CDATA[" };
string eTags[7] = {"</title>", "</country>", "]]></date>", "]]></time>", "]]></impact>", "]]></forecast>", "]]></previous>" };
char pocetTagu=7;

string impactS[4]={"Holiday","Low","Medium","High"}; //vet vech impact
char impactC[4]={-1,1,2,3}; // seln hodnoty pro impacty
char impactSloupec=5;
char impact[]; // tady jsou data impact, 0 = nic, 1 = low, 2 = medium, 3 = high, -1 = holiday

datetime datumCas[]; // tady jsou datumy a asy
char datumSloupec=3,casSloupec=4;

bool dataAno[]; // podle mn a impactu se ur jestli jsou ty data dleit nebo ne
char menySloupec=2;
string meny[9]={"USD","EUR","GBP","JPY","AUD","CAD","NZD","CHF","CNY"};
bool menyAno[9]; // kter mny brt a kter ne

bool DEA_vypni; // vypnout EA

int minulaZprava,pristiZprava; //indexy do pole pro nejbli zprvy
int zpravaZaXMin,zpravaPredXMin; //Za kolik minut a ped kolika minutama nejbli zprva se splnnma podmnkama mny a impactu

int barvaOld;
// LastDownloadTime - Global Variable, as poslednho downloadu zprv 

datetime dtmp=D'2015.03.14 12:17'; // tmp datetime pro testovn
bool pouzitDTMP=false;
//+------------------------------------------------------------------+
//| Cel program                                                     |
//+------------------------------------------------------------------+
void udelejVsechno()
  {
   string news;

   //lg("LastDownloadTime",(TimeCurrent()-GlobalVariableGet("LastDownloadTime")));
   if(GlobalVariableCheck("LastDownloadTime")==false || 
      (TimeCurrent()-GlobalVariableGet("LastDownloadTime"))>poKolikaHodDownload*3600) //M bt 3600
     {
      news=download(newsURL);
      //lg(news);
      ulozXMLdata(news);
      //lg("Download!!!");
     }

   news=nactiXMLdata();
   if(StringLen(news)<100)return;
   if(downloadOK==false)return; // Kdy nen v podku soubor news.xml, tak konec

   XMLdoPole(news); // do pole data[][7]   
   nactiDatumyACasy(); // do datumCas[]   
   nactiMeny(); // do dataAno[] jestli brt nebo ne ty data
   nactiImpacty(); // do impact[], mus bt a po nactiDatumyACasy()
   najdiNejblizsiZpravy();
   vypnoutEA(); // kontrola, jestli se m vypnout EA a vypnout ho
   cervenyGraf(); // pokud je povolen, tak se nastav graf naerveno pi vypnutch EA
   vypisInfoDoGrafu();
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer() // Dl se jednou za minutu
  {
   udelejVsechno();      
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   EventSetTimer(60); // create timer - m bt 60, pro testy 6
   barvaOld=ChartGetInteger(0,CHART_COLOR_BACKGROUND,0);
   IndicatorShortName("News Disable EA");

   menyAno[0]=USD_Ano;
   menyAno[1]=EUR_Ano;
   menyAno[2]=GBP_Ano;
   menyAno[3]=JPY_Ano;
   menyAno[4]=AUD_Ano;
   menyAno[5]=CAD_Ano;
   menyAno[6]=NZD_Ano;
   menyAno[7]=CHF_Ano;
   menyAno[8]=CNY_Ano;

   udelejVsechno();

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|  Custom indicator deinitialization function                      |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   EventKillTimer(); // destroy timer
   ChartSetInteger(0,CHART_COLOR_BACKGROUND,barvaOld);
   Comment("");
  }
//+------------------------------------------------------------------+
//| Funkce                                                           |
//+------------------------------------------------------------------+
void cervenyGraf() // D graf s tmto indiktorem do poped a obarv naerveno v okol zprvy, kdy jsou vypnut EA
  {
   if((cervenyGrafZap==true) && (DEA_vypni==true))
     {
      ChartSetInteger(0,CHART_BRING_TO_TOP,0,true);
      ChartSetInteger(0,CHART_COLOR_BACKGROUND,barvaWarning);
     }
   else ChartSetInteger(0,CHART_COLOR_BACKGROUND,barvaOld);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void vypnoutEA() // kontrola, jestli se m vypnout EA a vypnout ho
  {
   int DEA_BeforeNewsMin2;
   int DEA_AfterNewsMin2;

   DEA_BeforeNewsMin2=DEA_BeforeNewsMin;
   DEA_AfterNewsMin2=DEA_AfterNewsMin;
   if(DEA_BeforeNewsMin<2)DEA_BeforeNewsMin2=2;
   if(DEA_AfterNewsMin<2)DEA_AfterNewsMin2=2;

   if(DisableExpertAdvisors==true) // Maj se vypnout EA? Kontrola podle zadanch as
     {
      if((zpravaZaXMin<DEA_BeforeNewsMin2) || ((-1)*zpravaPredXMin<DEA_AfterNewsMin2))
        {
         DEA_vypni=true;
        }
      else DEA_vypni=false;
     }

   //lg("DEA_vypni",DEA_vypni);

   if(DEA_vypni==true)disableEA();
   else enableEA();
  }
//+------------------------------------------------------------------+
// Koment o nejblich zprvch do grafu                          |
//+------------------------------------------------------------------+
void vypisInfoDoGrafu()
  {
   string s,t,u;
   if(DEA_vypni==True)u="vypnut";
   else u="zapnut";
   t=" ----------------------------------------------"; // Oddlova mezi zprvama
   s=StringConcatenate(t,"\n",
                       "| Nejbli zprvy:\n",
                       t,"\n",
                       "| Za ",zpravaZaXMin," minut\n",
                       "| ",TimeToStr(datumCas[pristiZprava],TIME_DATE|TIME_MINUTES)," ",
                       data[pristiZprava][1]," ",
                       data[pristiZprava][4],"\n",
                       "| ",data[pristiZprava][0],"\n",
                       t,"\n",
                       "| Ped ",zpravaPredXMin," minutama\n",
                       "| ",TimeToStr(datumCas[minulaZprava],TIME_DATE|TIME_MINUTES)," ",
                       data[minulaZprava][1]," ",
                       data[minulaZprava][4],"\n",
                       "| ",data[minulaZprava][0],"\n",
                       t,"\n",
                       "| Auto Trading je ",u,"\n",
                       t
                       );
   Comment(s);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void najdiNejblizsiZpravy()
  {
   char j;
   datetime d,GMT;
   bool b;

   int zaKolikMin;
   zpravaZaXMin=100000;
   zpravaPredXMin=-100000;
   GMT=TimeGMT();
//GMT=D'2015.02.26 09:12';
   if(pouzitDTMP==true)GMT=dtmp;
   
   pristiZprava=0;
   minulaZprava=0;

   for(j=0;j<pocetEvents;j++)
     {
      b=dataAno[j];
      if(b==true) // jen vybran data podle mn a impactu
        {
         d=datumCas[j];
         zaKolikMin=(d-GMT)/60;
         if(zaKolikMin>=0)
           {
            if(zaKolikMin<zpravaZaXMin)
              {
               zpravaZaXMin=zaKolikMin;
               pristiZprava=j;
               //lg(zpravaZaXMin);
              }
           }
         if(zaKolikMin<=0)
           {
            if(zaKolikMin>zpravaPredXMin)
              {
               zpravaPredXMin=zaKolikMin;
               minulaZprava=j;
               //lg(zpravaPredXMin);
              }
           }
         //lg(j,TimeToStr(d,TIME_DATE|TIME_MINUTES),d-GMT,(d-GMT)/60);
        }
      //lg(j,s);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void nactiImpacty()
  {
   char i,j;
   string s;

   int arraySize=pocetEvents;
   ArrayResize(impact,arraySize);
   int pocetImpactu=ArraySize(impactS);

   for(j=0;j<arraySize;j++)
     {
      s=data[j][impactSloupec-1];
      //lg(j,s);
      for(i=0;i<pocetImpactu;i++)
        {
         if(s==impactS[i])
           {
            impact[j]=impactC[i]; // Zapise se do dat ciselne impact
            if(impact[j]<impactBratAspon) // tento impact nebrat
              {
               dataAno[j]=false; // proto sem false  
              }
            //lg(j,s,impact[j],dataAno[j]);
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void nactiMeny()
  {
   char i,j,pocetMen,stejny;
   string s,t;
   bool b;

   int arraySize=pocetEvents;
   ArrayResize(dataAno,arraySize);
   pocetMen=ArraySize(meny);

   for(j=0;j<arraySize;j++)
     {
      dataAno[j]=false;
      s=data[j][menySloupec-1];
      for(i=0;i<pocetMen;i++)
        {
         t=meny[i];
         stejny=StringCompare(s,t,false);
         if(stejny==0)
           {
            b=menyAno[i];
            if(b==true)dataAno[j]=true;
            break;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void nactiDatumyACasy()
  {
   int j;
   string s,t;
   datetime d;

   int arraySize=pocetEvents;
   ArrayResize(datumCas,arraySize);

   for(j=0;j<arraySize;j++)
     {
      s=data[j][datumSloupec-1];
      t=data[j][casSloupec-1];
      d=StrToTime(MakeDateTime(s,t));
      datumCas[j]=d;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string MakeDateTime(string strDate,string strTime)
  {
// Converts forexfactory time & date into yyyy.mm.dd hh:mm
   int n1stDash = StringFind(strDate, "-");
   int n2ndDash = StringFind(strDate, "-", n1stDash+1);

   string strMonth=StringSubstr(strDate,0,2);
   string strDay=StringSubstr(strDate,3,2);
   string strYear=StringSubstr(strDate,6,4);
//	strYear = "20" + strYear;

   int nTimeColonPos=StringFind(strTime,":");
   string strHour=StringSubstr(strTime,0,nTimeColonPos);
   string strMinute= StringSubstr(strTime,nTimeColonPos+1,2);
   string strAM_PM = StringSubstr(strTime,StringLen(strTime)-2);

   int nHour24=StrToInteger(strHour);
   if((strAM_PM=="pm" || strAM_PM=="PM") && nHour24!=12)
     {
      nHour24+=12;
     }
   if((strAM_PM=="am" || strAM_PM=="AM") && nHour24==12)
     {
      nHour24=0;
     }
   string strHourPad="";
   if(nHour24<10)
      strHourPad="0";

   return(StringConcatenate(strYear, ".", strMonth, ".", strDay, " ", strHourPad, nHour24, ":", strMinute));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void XMLdoPole(string news)
  {
   (StringReplace(news,"<event>","<event>"));
   pocetEvents=ArrayFromString(events,news,"");

   short i,j,k=0;
   string s,t;
   int p;

   int arraySize=ArraySize(events);
   ArrayResize(data,arraySize);

   for(j=0;j<pocetEvents;j++)
     {
      s=events[j];
      p=StringFind(s,"<event>");
      if(p>=0)
        {
         for(i=0;i<pocetTagu;i++)
           {
            s=StringSubstr(s,StringFind(s,sTags[i])+StringLen(sTags[i]));
            p=StringFind(s,eTags[i]);
            if(p>=0) t=StringSubstr(s,0,p);
            else t="";
            t=StringTrimLeft(t);
            t=StringTrimRight(t);
            data[k][i]=t;
           }
         k++;
        }
     }
   pocetEvents=k;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ulozXMLdata(string s)
  {
   int end;

   end=StringFind(s,"</weeklyevents>",0);
   if(end<=0)
     {
      downloadOK=false;
      Alert("Web page download was not complete!");
      //lg("Web page download was not complete!");
      //Oetit chybu - nestaen cel strnka news
      GlobalVariableDel("LastDownloadTime"); // Znovu download
      //lg("GlobalVariableDel");
     }
   else
     {
      // Ulo news do souboru
      int xmlHandle;
      xmlHandle=FileOpen("news.xml",FILE_BIN|FILE_WRITE);
      if(xmlHandle!=INVALID_HANDLE)
        {
         FileWriteString(xmlHandle,s,StringLen(s));
         //lg("GlobalVariableSet");
         GlobalVariableSet("LastDownloadTime",TimeCurrent());
         downloadOK=true;
        }
      FileClose(xmlHandle);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string nactiXMLdata()
  {
   ulong file_size=0,data_size=0;
   string s;
   int xmlHandle;

   xmlHandle=FileOpen("news.xml",FILE_BIN|FILE_READ);
   if(xmlHandle==INVALID_HANDLE)
     {
      downloadOK=false;
      Alert("Can\'t open xml file: news.xml.  The last error is ",GetLastError());
      GlobalVariableDel("LastDownloadTime"); // Znovu download
      //lg("GlobalVariableDel");
      return("");
     }

   s=FileReadString(xmlHandle,65536);
   bool pnt=FileSeek(xmlHandle,0,0);

   file_size = FileSize(xmlHandle);
   data_size = StringLen(s);

   if(data_size<file_size)
      s=s+FileReadString(xmlHandle,file_size);

   if(xmlHandle!=INVALID_HANDLE)
      FileClose(xmlHandle);

   downloadOK=true;
   return(s);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int ArrayFromString(string  &webResData[],string inputStr,string divider)
  {
   if(inputStr=="")
     {
      Alert("Input string is not set");
      return(0);
     }
   if(divider=="")
     {
      Alert("Separator is not set");
      return(0);
     }
   short i,stringCounter=0;

   string tmpChar,tmpString,tmpArr[64000];
   int inputStringLen=StringLen(inputStr);
   for(i=0; i<inputStringLen; i++)
     {
      tmpChar=StringSubstr(inputStr,i,1);
      tmpString=tmpString+tmpChar;
      tmpArr[stringCounter]=tmpString;
      if(tmpChar==divider)
        {
         stringCounter++;
         tmpString="";
        }
     }
   stringCounter++;
   if(stringCounter>0)
     {
      ArrayResize(webResData,stringCounter);
      for(i=0; i<stringCounter; i++) webResData[i]=tmpArr[i];
     }
   return (stringCounter);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int hSession(bool Direct)
  {
   int hSession_IEType=0;
   int hSession_Direct=0;
   int Internet_Open_Type_Preconfig=0;
   int Internet_Open_Type_Direct=1;
   string InternetAgent="Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461)";

   if(Direct)
     {
      if(hSession_Direct==0)
        {
         hSession_Direct=InternetOpenW(InternetAgent,Internet_Open_Type_Direct,"0","0",0);
        }

      return(hSession_Direct);
     }
   else
     {
      if(hSession_IEType==0)
        {
         hSession_IEType=InternetOpenW(InternetAgent,Internet_Open_Type_Preconfig,"0","0",0);
        }

      return(hSession_IEType);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string download(string strUrl)
  {
   int handler=hSession(false);
   int response=InternetOpenUrlW(handler,strUrl,NULL,0,INTERNET_FLAG_NO_CACHE_WRITE|INTERNET_FLAG_PRAGMA_NOCACHE|INTERNET_FLAG_RELOAD,0);
   if(response == 0)
      return(false);

   uchar ch[100]; string toStr=""; int dwBytes,h=-1;
   while(InternetReadFile(response,ch,100,dwBytes))
     {
      if(dwBytes<=0) break; toStr=toStr+CharArrayToString(ch,0,dwBytes);
     }

   InternetCloseHandle(response);
   return toStr;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void enableEA() // Zapne Auto Trading
  {
   if(IsExpertEnabled()==False)switchAutoTrading();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void disableEA() // Vypne Auto Trading
  {
   if(IsExpertEnabled()==True)switchAutoTrading();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void switchAutoTrading() // Pepne tlatko Auto Trading 
  {
   int hChart=WindowHandle(Symbol(),Period());
   int hMetaTrader=GetAncestor(hChart,2);
   int HandlToolbar=GetDlgItem(hMetaTrader,0x63);
   PostMessageA(hMetaTrader,WM_COMMAND,EABUTTON,0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],const double &open[],const double &high[],const double &low[],const double &close[],const long &tick_volume[],const long &volume[],const int &spread[])
  {
//Nic   
   return(rates_total);
  }
//+------------------------------------------------------------------+
